com.fasterxml.jackson.databind.type

## Class SimpleType

- java.lang.Object
- - com.fasterxml.jackson.core.type.ResolvedType
  - - com.fasterxml.jackson.databind.JavaType
    - - com.fasterxml.jackson.databind.type.TypeBase
      - - com.fasterxml.jackson.databind.type.SimpleType

All Implemented Interfaces:
  JsonSerializable, Serializable, Type

Direct Known Subclasses:
  ReferenceType

    public class SimpleType
    extends TypeBase

Simple types are defined as anything other than one of recognized container types (arrays, Collections, Maps). For our needs we need not know anything further, since we have no way of dealing with generic types other than Collections and Maps.

See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from interface com.fasterxml.jackson.databind.JsonSerializable

`JsonSerializable.Base`

### Field Summary

### Fields inherited from class com.fasterxml.jackson.databind.type.TypeBase

`_bindings, _superClass, _superInterfaces`

### Fields inherited from class com.fasterxml.jackson.databind.JavaType

`_asStatic, _class, _hash, _typeHandler, _valueHandler`

### Constructor Summary

Constructors
`protected` `SimpleType(Class<?> cls)` Constructor only used by core Jackson databind functionality; should never be called by application code.
`protected` `SimpleType(Class<?> cls, TypeBindings bindings, JavaType superClass, JavaType[] superInts)`
`protected` `SimpleType(Class<?> cls, TypeBindings bindings, JavaType superClass, JavaType[] superInts, int extraHash, Object valueHandler, Object typeHandler, boolean asStatic)` Pass-through constructor used by `ReferenceType`.
`protected` `SimpleType(Class<?> cls, TypeBindings bindings, JavaType superClass, JavaType[] superInts, Object valueHandler, Object typeHandler, boolean asStatic)`
`protected` `SimpleType(TypeBase base)` Simple copy-constructor, usually used when upgrading/refining a simple type into more specialized type.

### Method Summary

Methods
`protected JavaType` `_narrow(Class<?> subclass)` Deprecated.
`protected String` `buildCanonicalName()`
`static SimpleType` `construct(Class<?> cls)` Deprecated. Since 2.7
`static SimpleType` `constructUnsafe(Class<?> raw)` Method used by core Jackson classes: NOT to be used by application code: it does NOT properly handle inspection of super-types, so neither parent Classes nor implemented Interfaces are accessible with resulting type instance.
`boolean` `equals(Object o)`
`StringBuilder` `getErasedSignature(StringBuilder sb)` Method for accessing signature without generic type information, in form compatible with all versions of JVM, and specifically used for type descriptions when generating byte code.
`StringBuilder` `getGenericSignature(StringBuilder sb)`
`boolean` `hasContentType()` Accessor that allows determining whether `JavaType.getContentType()` should return a non-null value (that is, there is a "content type") or not.
`boolean` `isContainerType()`
`JavaType` `refine(Class<?> rawType, TypeBindings bindings, JavaType superClass, JavaType[] superInterfaces)` Mutant factory method that will try to create and return a sub-type instance for known parameterized types; for other types will return `null` to indicate that no just refinement makes necessary sense, without trying to detect special status through implemented interfaces.
`String` `toString()`
`JavaType` `withContentType(JavaType contentType)` Mutant factory method that may be called on structured types that have a so-called content type (element of arrays, value type of Maps, referenced type of referential types), and will construct a new instance that is identical to this instance, except that it has specified content type, instead of current one.
`JavaType` `withContentTypeHandler(Object h)` Mutant factory method that will construct a new instance that is identical to this instance, except that it will have specified content type (element type for arrays, value type for Maps and so forth) handler assigned.
`SimpleType` `withContentValueHandler(Object h)` Mutant factory method that will construct a new instance that is identical to this instance, except that it will have specified content value handler assigned.
`SimpleType` `withStaticTyping()` Method that can be called to get a type instance that indicates that values of the type should be handled using "static typing" for purposes of serialization (as opposed to "dynamic" aka runtime typing): meaning that no runtime information is needed for determining serializers to use.
`SimpleType` `withTypeHandler(Object h)` "Copy method" that will construct a new instance that is identical to this instance, except that it will have specified type handler assigned.
`SimpleType` `withValueHandler(Object h)` Mutant factory method that will construct a new instance that is identical to this instance, except that it will have specified value handler assigned.

### Methods inherited from class com.fasterxml.jackson.databind.type.TypeBase

`_bogusSuperClass, _classSignature, containedType, containedTypeCount, containedTypeName, findSuperType, findTypeParameters, getBindings, getInterfaces, getSuperClass, getTypeHandler, getValueHandler, serialize, serializeWithType, toCanonical`

### Methods inherited from class com.fasterxml.jackson.databind.JavaType

`containedTypeOrUnknown, forcedNarrowBy, getContentType, getContentTypeHandler, getContentValueHandler, getErasedSignature, getGenericSignature, getKeyType, getParameterSource, getRawClass, getReferencedType, hasGenericTypes, hashCode, hasRawClass, hasValueHandler, isAbstract, isArrayType, isCollectionLikeType, isConcrete, isEnumType, isFinal, isInterface, isJavaLangObject, isMapLikeType, isPrimitive, isThrowable, isTypeOrSubTypeOf, useStaticType`

### Methods inherited from class com.fasterxml.jackson.core.type.ResolvedType

`isReferenceType`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### SimpleType

    protected SimpleType(Class<?> cls)

Constructor only used by core Jackson databind functionality; should never be called by application code.

As with other direct construction that by-passes `TypeFactory`, no introspection occurs with respect to super-types; caller must be aware of consequences if using this method.

#### SimpleType

    protected SimpleType(Class<?> cls,
              TypeBindings bindings,
              JavaType superClass,
              JavaType[] superInts)

#### SimpleType

    protected SimpleType(TypeBase base)

Simple copy-constructor, usually used when upgrading/refining a simple type into more specialized type.

Since:
  2.7

#### SimpleType

    protected SimpleType(Class<?> cls,
              TypeBindings bindings,
              JavaType superClass,
              JavaType[] superInts,
              Object valueHandler,
              Object typeHandler,
              boolean asStatic)

#### SimpleType

    protected SimpleType(Class<?> cls,
              TypeBindings bindings,
              JavaType superClass,
              JavaType[] superInts,
              int extraHash,
              Object valueHandler,
              Object typeHandler,
              boolean asStatic)

Pass-through constructor used by `ReferenceType`.

Since:
  2.6

### Method Detail

#### constructUnsafe

    public static SimpleType constructUnsafe(Class<?> raw)

Method used by core Jackson classes: NOT to be used by application code: it does NOT properly handle inspection of super-types, so neither parent Classes nor implemented Interfaces are accessible with resulting type instance.

NOTE: public only because it is called by `ObjectMapper` which is not in same package

#### construct

    @Deprecated
    public static SimpleType construct(Class<?> cls)

Deprecated. Since 2.7
Method that should NOT to be used by application code: it does NOT properly handle inspection of super-types, so neither parent Classes nor implemented Interfaces are accessible with resulting type instance. Instead, please use `TypeFactory`'s `constructType` methods which handle introspection appropriately.

Note that prior to 2.7, method usage was not limited and would typically have worked acceptably: the problem comes from inability to resolve super-type information, for which `TypeFactory` is needed.

#### _narrow

    @Deprecated
    protected JavaType _narrow(Class<?> subclass)

Deprecated.

Specified by:
  `_narrow` in class `JavaType`

#### withContentType

    public JavaType withContentType(JavaType contentType)

Description copied from class: `JavaType`
Mutant factory method that may be called on structured types that have a so-called content type (element of arrays, value type of Maps, referenced type of referential types), and will construct a new instance that is identical to this instance, except that it has specified content type, instead of current one. If content type is already set to given type, `this` is returned. If type does not have a content type (which is the case with `SimpleType`), `IllegalArgumentException` will be thrown.

Specified by:
  `withContentType` in class `JavaType`
Returns:
  Newly created type instance

#### withTypeHandler

    public SimpleType withTypeHandler(Object h)

Description copied from class: `JavaType`
"Copy method" that will construct a new instance that is identical to this instance, except that it will have specified type handler assigned.

Specified by:
  `withTypeHandler` in class `JavaType`
Returns:
  Newly created type instance

#### withContentTypeHandler

    public JavaType withContentTypeHandler(Object h)

Description copied from class: `JavaType`
Mutant factory method that will construct a new instance that is identical to this instance, except that it will have specified content type (element type for arrays, value type for Maps and so forth) handler assigned.

Specified by:
  `withContentTypeHandler` in class `JavaType`
Returns:
  Newly created type instance, with given

#### withValueHandler

    public SimpleType withValueHandler(Object h)

Description copied from class: `JavaType`
Mutant factory method that will construct a new instance that is identical to this instance, except that it will have specified value handler assigned.

Specified by:
  `withValueHandler` in class `JavaType`
Returns:
  Newly created type instance

#### withContentValueHandler

    public SimpleType withContentValueHandler(Object h)

Description copied from class: `JavaType`
Mutant factory method that will construct a new instance that is identical to this instance, except that it will have specified content value handler assigned.

Specified by:
  `withContentValueHandler` in class `JavaType`
Returns:
  Newly created type instance

#### withStaticTyping

    public SimpleType withStaticTyping()

Description copied from class: `JavaType`
Method that can be called to get a type instance that indicates that values of the type should be handled using "static typing" for purposes of serialization (as opposed to "dynamic" aka runtime typing): meaning that no runtime information is needed for determining serializers to use. The main use case is to allow forcing of specific root value serialization type, and specifically in resolving serializers for contained types (element types for arrays, Collections and Maps).

Specified by:
  `withStaticTyping` in class `JavaType`

#### refine

    public JavaType refine(Class<?> rawType,
                  TypeBindings bindings,
                  JavaType superClass,
                  JavaType[] superInterfaces)

Description copied from class: `JavaType`
Mutant factory method that will try to create and return a sub-type instance for known parameterized types; for other types will return `null` to indicate that no just refinement makes necessary sense, without trying to detect special status through implemented interfaces.

Specified by:
  `refine` in class `JavaType`

#### buildCanonicalName

    protected String buildCanonicalName()

Overrides:
  `buildCanonicalName` in class `TypeBase`

#### isContainerType

    public boolean isContainerType()

Specified by:
  `isContainerType` in class `JavaType`
Returns:
  True if type represented is a container type; this includes array, Map and Collection types.

#### hasContentType

    public boolean hasContentType()

Description copied from class: `JavaType`
Accessor that allows determining whether `JavaType.getContentType()` should return a non-null value (that is, there is a "content type") or not. True if `JavaType.isContainerType()` or `ResolvedType.isReferenceType()` return true.

Overrides:
  `hasContentType` in class `JavaType`

#### getErasedSignature

    public StringBuilder getErasedSignature(StringBuilder sb)

Description copied from class: `JavaType`
Method for accessing signature without generic type information, in form compatible with all versions of JVM, and specifically used for type descriptions when generating byte code.

Specified by:
  `getErasedSignature` in class `TypeBase`
Parameters:
  `sb` - StringBuilder to append signature to
Returns:
  StringBuilder that was passed in; returned to allow call chaining

#### getGenericSignature

    public StringBuilder getGenericSignature(StringBuilder sb)

Specified by:
  `getGenericSignature` in class `TypeBase`
Parameters:
  `sb` - StringBuilder to append signature to
Returns:
  StringBuilder that was passed in; returned to allow call chaining

#### toString

    public String toString()

Specified by:
  `toString` in class `JavaType`

#### equals

    public boolean equals(Object o)

Specified by:
  `equals` in class `JavaType`